Running the Workspace Generator
-------------------------------

The most common way to use the Make Project Creator is to run the
workspace generator (mwc.pl).  This script will generate projects and a
single workspace that contains the generated projects.  If no input file
(.mwc file) is specified, it will recurse into the directory in which the
script was started.  It looks for .mpc files and generates a project or
projects for each one found.


Usage: mwc.pl [-global <file>] [-include <directory>]
              [-ti <dll | lib | dll_exe | lib_exe>:<file>]
              [-template <file>] [-dynamic_only] [-static_only]
              [-relative NAME=VAR] [-noreldefs]
              [-value_template <NAME+=VAL | NAME=VAL | NAME-=VAL>]
              [-value_project <NAME+=VAL | NAME=VAL | NAME-=VAL>]
              [-type <bor | em3 | ghs | gnu | nma | va4 | vc6 | vc7>]
              [files]

       -global         Specifies the global input file.  Values stored
                       within this file are applied to all projects.
       -include        Specifies a directory to search when looking for base
                       projects, template input files and templates.  This
                       option can be used multiple times to add directories.
       -ti             Specifies the template input file (with no extension)
                       for the specific type as shown above
                       (ex. -ti dll_exe:vc8exe)
       -template       Specifies the template name (with no extension).
       -dynamic_only   Specifies that only dynamic projects will be generated.
       -static_only    Specifies that only static projects will be generated.
       -relative       Any $() variable in an mpc that is matched to NAME
                       is replaced by VAR only if VAR can be made into a
                       relative path based on the current working directory.
       -noreldefs      Do not try to generate default relative definitions.
       -value_template This option allows modification of a template input
                       name value pair.  Use += to add VAL to the NAME's
                       value.  Use -= to subtract and = to override the value.
                       It is important to note that this will only modify
                       existing template input name value pairs and can not
                       be used to introduce new name value pairs.
       -value_project  This option allows modification of a project variable
                       assignment .  Use += to add VAL to the NAME's value.
                       Use -= to subtract and = to override the value.
                       This can be used to introduce new name value pairs to
                       a project.  However, it must be a valid project
                       assignment.
       -type           Specifies the type of project file to generate.  This
                       option can be used multiple times to generate multiple
                       types.  If -type is not used, it defaults to 'gnu'.

The default global input file
(ACE_wrappers/bin/MakeProjectCreator/config/global.mpb) is used if -global
is not specified on the command line.

Two include directories are used by default
(ACE_wrappers/bin/MakeProjectCreator/config and
ACE_wrappers/bin/MakeProjectCreator/templates).

Each project creator has a default template input file for each type of
project (dll_exe, lib_exe, dll, lib).  You can override the default template
input file name with the -ti option.  The file must have a 'mpt' extension
and must reside within the include search directories.  NOTE: the 'lib' and
the 'lib_exe' template input files are only used if the project creator makes
a separate project file for dynamic libraries and static libraries.

The -template option is used to override the default template name.  This
file should have a .mpd extension and sit in one of the include search
directories.  NOTE: The -template option overrides the template file for all
types specified.

The -dynamic_only option can be used to avoid generating static project
files.  This currently only applies to the vc6 type.

The -static_only option can be used to avoid generating dynamic project
files.  This currently only applies to the vc6 type.

The -noreldefs option says not to generate default relative definitions for
ACE_ROOT and TAO_ROOT (which would come from environment variables).

The -type option can be used multiple times on the same command line to
generate projects of different types per mpc file.  The default type is
always gnu.  NOTE: The -ti option overrides the template input file for all
types specified.


Running only the Project Generator
----------------------------------

Most of what is stated about the Workspace Generator applies to the Project
Generator except that it only generates projects.  If an input file (.mpc
file) is not provided, the project creator will attempt to create a default
project in the directory from which the script was started.


Usage: mpc.pl [-global <file>] [-include <directory>]
              [-ti <dll | lib | dll_exe | lib_exe>:<file>]
              [-template <file>] [-dynamic_only] [-static_only]
              [-relative NAME=VAR] [-noreldefs]
              [-value_template <NAME+=VAL | NAME=VAL | NAME-=VAL>]
              [-value_project <NAME+=VAL | NAME=VAL | NAME-=VAL>]
              [-type <bor | em3 | ghs | gnu | nma | va4 | vc6 | vc7>]
              [files]

       -global         Specifies the global input file.  Values stored
                       within this file are applied to all projects.
       -include        Specifies a directory to search when looking for base
                       projects, template input files and templates.  This
                       option can be used multiple times to add directories.
       -ti             Specifies the template input file (with no extension)
                       for the specific type as shown above
                       (ex. -ti dll_exe:vc8exe)
       -template       Specifies the template name (with no extension).
       -dynamic_only   Specifies that only dynamic projects will be generated.
       -static_only    Specifies that only static projects will be generated.
       -relative       Any $() variable in an mpc that is matched to NAME
                       is replaced by VAR only if VAR can be made into a
                       relative path based on the current working directory.
       -noreldefs      Do not try to generate default relative definitions.
       -value_template This option allows modification of a template input
                       name value pair.  Use += to add VAL to the NAME's
                       value.  Use -= to subtract and = to override the value.
                       It is important to note that this will only modify
                       existing template input name value pairs and can not
                       be used to introduce new name value pairs.
       -value_project  This option allows modification of a project variable
                       assignment .  Use += to add VAL to the NAME's value.
                       Use -= to subtract and = to override the value.
                       This can be used to introduce new name value pairs to
                       a project.  However, it must be a valid project
                       assignment.
       -type           Specifies the type of project file to generate.  This
                       option can be used multiple times to generate multiple
                       types.  If -type is not used, it defaults to 'gnu'.
